Package org.springframework.security.access.intercept

# Interface AfterInvocationManager

All Known Implementing Classes:
  `AfterInvocationProviderManager`

@Deprecated public interface AfterInvocationManager
Deprecated.
Use delegation with `AuthorizationManager`
Reviews the `Object` returned from a secure object invocation, being able to modify the `Object` or throw an `AccessDeniedException`.

Typically used to ensure the principal is permitted to access the domain object instance returned by a service layer bean. Can also be used to mutate the domain object instance so the principal is only able to access authorised bean properties or `Collection` elements.

Special consideration should be given to using an `AfterInvocationManager` on bean methods that modify a database. Typically an `AfterInvocationManager` is used with read-only methods, such as `public DomainObject getById(id)`. If used with methods that modify a database, a transaction manager should be used to ensure any `AccessDeniedException` will cause a rollback of the changes made by the transaction.

See Also:
  - `AuthorizationManagerBeforeMethodInterceptor`
  - `AuthorizationManagerAfterMethodInterceptor`

## Method Summary

Modifier and Type
Method
Description
`Object`
`decide(Authentication authentication, Object object, Collection<ConfigAttribute> attributes, Object returnedObject)`
Deprecated.
Given the details of a secure object invocation including its returned `Object`, make an access control decision or optionally modify the returned `Object`.
`boolean`
`supports(Class<?> clazz)`
Deprecated.
Indicates whether the `AfterInvocationManager` implementation is able to provide access control decisions for the indicated secured object type.
`boolean`
`supports(ConfigAttribute attribute)`
Deprecated.
Indicates whether this `AfterInvocationManager` is able to process "after invocation" requests presented with the passed `ConfigAttribute`.

## Method Details

### decide

Object decide(Authentication authentication, Object object, Collection<ConfigAttribute> attributes, Object returnedObject) throws AccessDeniedException
Deprecated.
Given the details of a secure object invocation including its returned `Object`, make an access control decision or optionally modify the returned `Object`.

Parameters:
  `authentication` - the caller that invoked the method
  `object` - the secured object that was called
  `attributes` - the configuration attributes associated with the secured object that was invoked
  `returnedObject` - the `Object` that was returned from the secure object invocation
Returns:
  the `Object` that will ultimately be returned to the caller (if an implementation does not wish to modify the object to be returned to the caller, the implementation should simply return the same object it was passed by the `returnedObject` method argument)
Throws:
  `AccessDeniedException` - if access is denied

### supports

boolean supports(ConfigAttribute attribute)
Deprecated.
Indicates whether this `AfterInvocationManager` is able to process "after invocation" requests presented with the passed `ConfigAttribute`.

This allows the `AbstractSecurityInterceptor` to check every configuration attribute can be consumed by the configured `AccessDecisionManager` and/or `RunAsManager` and/or `AfterInvocationManager`.

Parameters:
  `attribute` - a configuration attribute that has been configured against the `AbstractSecurityInterceptor`
Returns:
  true if this `AfterInvocationManager` can support the passed configuration attribute

### supports

boolean supports(Class<?> clazz)
Deprecated.
Indicates whether the `AfterInvocationManager` implementation is able to provide access control decisions for the indicated secured object type.

Parameters:
  `clazz` - the class that is being queried
Returns:
  `true` if the implementation can process the indicated class